Bug 800346 - Guvnor BPMN designer cannot import process with missing bpmndi:BPMNShape element
Guvnor BPMN designer cannot import process with missing bpmndi:BPMNShape element
Status: VERIFIED
Product: JBoss Enterprise BRMS Platform 5
Classification: JBoss
Component: BRM (Guvnor) (Show other bugs)
BRMS 5.3.0.GA
Unspecified Unspecified
unspecified Severity medium
: ---
: BRMS 5.3.0.GA
Assigned To: Tihomir Surdilovic
Radovan Synek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-03-06 06:24 EST by Radovan Synek
Modified: 2012-05-03 22:49 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
process definition (2.19 KB, application/octet-stream)
2012-03-06 06:24 EST, Radovan Synek
no flags Details
screenshot (149.15 KB, image/png)
2012-03-06 06:25 EST, Radovan Synek
no flags Details

  None (edit)
Description Radovan Synek 2012-03-06 06:24:06 EST
Created attachment 567917 [details]
process definition

In order to import any process definition into Guvnor BPMN designer, each node has to have corresponding bpmndi:BPMNShape element inside BPMNDiagram definition. BPMN2 specification says that diagram depicts all model elements as well as only part of them.


Steps to Reproduce:
1. Start the Guvnor, create new BPMN2 process.
2. Choose "Import from BPMN2" in BPMN designer and load attached process definition (BPMNShape element is missing for dataObject element).
3. Error window appears without any kind of information what is wrong (see attached sceenshot) and no process definition is imported.
Comment 1 Radovan Synek 2012-03-06 06:25:27 EST
Created attachment 567919 [details]
screenshot
Comment 2 Tihomir Surdilovic 2012-03-06 06:42:19 EST
Yes this is a requirement for Designer - to have valid BPMN2 which can be parsed and presented properly. 

Thanks.
Comment 3 Lukáš Petrovický 2012-03-06 09:40:52 EST
(In reply to comment #2)
> Yes this is a requirement for Designer - to have valid BPMN2 which can be
> parsed and presented properly. 

In our understanding of the spec, the document is valid. 

See comment 0: "BPMN2 specification says that diagram depicts all model elements as well as only part of them."
Comment 4 Tihomir Surdilovic 2012-03-06 09:49:32 EST
Ok for model elements, but here we are talking about the notation of the model elements, which is required for a editor to be able to draw the diagram for you. Otherwise you may want to use a text-based editor.
Comment 5 Tihomir Surdilovic 2012-03-06 09:51:53 EST
Designer has visual support for Data Objects, Lanes, and Groups. Data Objects are model elements and thus have a notation section as well. I understand that possibly in Eclipse or via text-based editing you can create a Data Object but it cannot be represented in Designer without its notation (DI) info.

What we do with lanes now when you import a process from Eclipse that has lanes, we ignore these lanes and you have to add them back visually in Designer. With data objects we could do the same if you so wish.
Comment 6 Lukáš Petrovický 2012-03-06 10:05:07 EST
(In reply to comment #5)
> What we do with lanes now when you import a process from Eclipse that has
> lanes, we ignore these lanes and you have to add them back visually in
> Designer. With data objects we could do the same if you so wish.

I do consider it better than just rejecting a valid BPMN file.
Comment 7 Tihomir Surdilovic 2012-03-14 15:18:54 EDT
Added code to not marshall Data Objects if no DI info can be found. Code in master and 2.1.x Designer branch. Let me know if I need to provide a war for testing or if you guys can build. Server logs also indicate what was removed, for example for the process attached to this BZ:

15:14:35,825 INFO  [org.jbpm.designer.bpmn2.impl.Bpmn2JsonMarshaller] (http-localhost-127.0.0.1-8080-1) Could not find BPMNDI information for org.eclipse.bpmn2.impl.DataObjectImpl@69a585cf (id: employee, anyAttribute: []) (name: null) (isCollection: false)
15:14:35,826 INFO  [org.jbpm.designer.bpmn2.impl.Bpmn2JsonMarshaller] (http-localhost-127.0.0.1-8080-1) Could not marshall Data Object org.eclipse.bpmn2.impl.DataObjectImpl@69a585cf (id: employee, anyAttribute: []) (name: null) (isCollection: false) because no DI information could be found.
Comment 8 Ryan Zhang 2012-03-21 06:07:05 EDT
Please verify this issue on ER5.

Thanks!

Note You need to log in before you can comment on or make changes to this bug.